# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.body import Body
from google_docs_ti.models.document_style import DocumentStyle
from google_docs_ti.models.named_styles import NamedStyles
from typing import Optional, Set
from typing_extensions import Self

class DocumentTab(BaseModel):
    """
    A tab with document contents.
    """ # noqa: E501
    body: Optional[Body] = None
    document_style: Optional[DocumentStyle] = Field(default=None, alias="documentStyle")
    footers: Optional[Dict[str, Any]] = Field(default=None, description="The footers in the document tab, keyed by footer ID.")
    footnotes: Optional[Dict[str, Any]] = Field(default=None, description="The footnotes in the document tab, keyed by footnote ID.")
    headers: Optional[Dict[str, Any]] = Field(default=None, description="The headers in the document tab, keyed by header ID.")
    inline_objects: Optional[Dict[str, Any]] = Field(default=None, description="The inline objects in the document tab, keyed by object ID.", alias="inlineObjects")
    lists: Optional[Dict[str, Any]] = Field(default=None, description="The lists in the document tab, keyed by list ID.")
    named_ranges: Optional[Dict[str, Any]] = Field(default=None, description="The named ranges in the document tab, keyed by name.", alias="namedRanges")
    named_styles: Optional[NamedStyles] = Field(default=None, alias="namedStyles")
    positioned_objects: Optional[Dict[str, Any]] = Field(default=None, description="The positioned objects in the document tab, keyed by object ID.", alias="positionedObjects")
    suggested_document_style_changes: Optional[Dict[str, Any]] = Field(default=None, description="The suggested changes to the style of the document tab, keyed by suggestion ID.", alias="suggestedDocumentStyleChanges")
    suggested_named_styles_changes: Optional[Dict[str, Any]] = Field(default=None, description="The suggested changes to the named styles of the document tab, keyed by suggestion ID.", alias="suggestedNamedStylesChanges")
    __properties: ClassVar[List[str]] = ["body", "documentStyle", "footers", "footnotes", "headers", "inlineObjects", "lists", "namedRanges", "namedStyles", "positionedObjects", "suggestedDocumentStyleChanges", "suggestedNamedStylesChanges"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DocumentTab from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of body
        if self.body:
            _dict['body'] = self.body.to_dict()
        # override the default output from pydantic by calling `to_dict()` of document_style
        if self.document_style:
            _dict['documentStyle'] = self.document_style.to_dict()
        # override the default output from pydantic by calling `to_dict()` of named_styles
        if self.named_styles:
            _dict['namedStyles'] = self.named_styles.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DocumentTab from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "body": Body.from_dict(obj["body"]) if obj.get("body") is not None else None,
            "documentStyle": DocumentStyle.from_dict(obj["documentStyle"]) if obj.get("documentStyle") is not None else None,
            "footers": obj.get("footers"),
            "footnotes": obj.get("footnotes"),
            "headers": obj.get("headers"),
            "inlineObjects": obj.get("inlineObjects"),
            "lists": obj.get("lists"),
            "namedRanges": obj.get("namedRanges"),
            "namedStyles": NamedStyles.from_dict(obj["namedStyles"]) if obj.get("namedStyles") is not None else None,
            "positionedObjects": obj.get("positionedObjects"),
            "suggestedDocumentStyleChanges": obj.get("suggestedDocumentStyleChanges"),
            "suggestedNamedStylesChanges": obj.get("suggestedNamedStylesChanges")
        })
        return _obj


