# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.crop_properties_suggestion_state import CropPropertiesSuggestionState
from typing import Optional, Set
from typing_extensions import Self

class ImagePropertiesSuggestionState(BaseModel):
    """
    A mask that indicates which of the fields on the base ImageProperties have been changed in this suggestion. For any field set to true, there's a new suggested value.
    """ # noqa: E501
    angle_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to angle.", alias="angleSuggested")
    brightness_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to brightness.", alias="brightnessSuggested")
    content_uri_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to content_uri.", alias="contentUriSuggested")
    contrast_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to contrast.", alias="contrastSuggested")
    crop_properties_suggestion_state: Optional[CropPropertiesSuggestionState] = Field(default=None, alias="cropPropertiesSuggestionState")
    source_uri_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to source_uri.", alias="sourceUriSuggested")
    transparency_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to transparency.", alias="transparencySuggested")
    __properties: ClassVar[List[str]] = ["angleSuggested", "brightnessSuggested", "contentUriSuggested", "contrastSuggested", "cropPropertiesSuggestionState", "sourceUriSuggested", "transparencySuggested"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ImagePropertiesSuggestionState from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of crop_properties_suggestion_state
        if self.crop_properties_suggestion_state:
            _dict['cropPropertiesSuggestionState'] = self.crop_properties_suggestion_state.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ImagePropertiesSuggestionState from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "angleSuggested": obj.get("angleSuggested"),
            "brightnessSuggested": obj.get("brightnessSuggested"),
            "contentUriSuggested": obj.get("contentUriSuggested"),
            "contrastSuggested": obj.get("contrastSuggested"),
            "cropPropertiesSuggestionState": CropPropertiesSuggestionState.from_dict(obj["cropPropertiesSuggestionState"]) if obj.get("cropPropertiesSuggestionState") is not None else None,
            "sourceUriSuggested": obj.get("sourceUriSuggested"),
            "transparencySuggested": obj.get("transparencySuggested")
        })
        return _obj


