# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.inline_object_properties import InlineObjectProperties
from typing import Optional, Set
from typing_extensions import Self

class InlineObject(BaseModel):
    """
    An object that appears inline with text. An InlineObject contains an EmbeddedObject such as an image.
    """ # noqa: E501
    inline_object_properties: Optional[InlineObjectProperties] = Field(default=None, alias="inlineObjectProperties")
    object_id: Optional[StrictStr] = Field(default=None, description="The ID of this inline object. Can be used to update an object’s properties.", alias="objectId")
    suggested_deletion_ids: Optional[List[StrictStr]] = Field(default=None, description="The suggested deletion IDs. If empty, then there are no suggested deletions of this content.", alias="suggestedDeletionIds")
    suggested_inline_object_properties_changes: Optional[Dict[str, Any]] = Field(default=None, description="The suggested changes to the inline object properties, keyed by suggestion ID.", alias="suggestedInlineObjectPropertiesChanges")
    suggested_insertion_id: Optional[StrictStr] = Field(default=None, description="The suggested insertion ID. If empty, then this is not a suggested insertion.", alias="suggestedInsertionId")
    __properties: ClassVar[List[str]] = ["inlineObjectProperties", "objectId", "suggestedDeletionIds", "suggestedInlineObjectPropertiesChanges", "suggestedInsertionId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InlineObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of inline_object_properties
        if self.inline_object_properties:
            _dict['inlineObjectProperties'] = self.inline_object_properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InlineObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "inlineObjectProperties": InlineObjectProperties.from_dict(obj["inlineObjectProperties"]) if obj.get("inlineObjectProperties") is not None else None,
            "objectId": obj.get("objectId"),
            "suggestedDeletionIds": obj.get("suggestedDeletionIds"),
            "suggestedInlineObjectPropertiesChanges": obj.get("suggestedInlineObjectPropertiesChanges"),
            "suggestedInsertionId": obj.get("suggestedInsertionId")
        })
        return _obj


