# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.bookmark_link import BookmarkLink
from google_docs_ti.models.heading_link import HeadingLink
from typing import Optional, Set
from typing_extensions import Self

class Link(BaseModel):
    """
    A reference to another portion of a document or an external URL resource.
    """ # noqa: E501
    bookmark: Optional[BookmarkLink] = None
    bookmark_id: Optional[StrictStr] = Field(default=None, description="The ID of a bookmark in this document. Legacy field: Instead, set includeTabsContent to `true` and use Link.bookmark for read and write operations. This field is only returned when includeTabsContent is set to `false` in documents containing a single tab and links to a bookmark within the singular tab. Otherwise, Link.bookmark is returned. If this field is used in a write request, the bookmark is considered to be from the tab ID specified in the request. If a tab ID is not specified in the request, it is considered to be from the first tab in the document.", alias="bookmarkId")
    heading: Optional[HeadingLink] = None
    heading_id: Optional[StrictStr] = Field(default=None, description="The ID of a heading in this document. Legacy field: Instead, set includeTabsContent to `true` and use Link.heading for read and write operations. This field is only returned when includeTabsContent is set to `false` in documents containing a single tab and links to a heading within the singular tab. Otherwise, Link.heading is returned. If this field is used in a write request, the heading is considered to be from the tab ID specified in the request. If a tab ID is not specified in the request, it is considered to be from the first tab in the document.", alias="headingId")
    tab_id: Optional[StrictStr] = Field(default=None, description="The ID of a tab in this document.", alias="tabId")
    url: Optional[StrictStr] = Field(default=None, description="An external URL.")
    __properties: ClassVar[List[str]] = ["bookmark", "bookmarkId", "heading", "headingId", "tabId", "url"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Link from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of bookmark
        if self.bookmark:
            _dict['bookmark'] = self.bookmark.to_dict()
        # override the default output from pydantic by calling `to_dict()` of heading
        if self.heading:
            _dict['heading'] = self.heading.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Link from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bookmark": BookmarkLink.from_dict(obj["bookmark"]) if obj.get("bookmark") is not None else None,
            "bookmarkId": obj.get("bookmarkId"),
            "heading": HeadingLink.from_dict(obj["heading"]) if obj.get("heading") is not None else None,
            "headingId": obj.get("headingId"),
            "tabId": obj.get("tabId"),
            "url": obj.get("url")
        })
        return _obj


