# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.list_properties import ListProperties
from typing import Optional, Set
from typing_extensions import Self

class List(BaseModel):
    """
    A List represents the list attributes for a group of paragraphs that all belong to the same list. A paragraph that's part of a list has a reference to the list's ID in its bullet.
    """ # noqa: E501
    list_properties: Optional[ListProperties] = Field(default=None, alias="listProperties")
    suggested_deletion_ids: Optional[List[StrictStr]] = Field(default=None, description="The suggested deletion IDs. If empty, then there are no suggested deletions of this list.", alias="suggestedDeletionIds")
    suggested_insertion_id: Optional[StrictStr] = Field(default=None, description="The suggested insertion ID. If empty, then this is not a suggested insertion.", alias="suggestedInsertionId")
    suggested_list_properties_changes: Optional[Dict[str, Any]] = Field(default=None, description="The suggested changes to the list properties, keyed by suggestion ID.", alias="suggestedListPropertiesChanges")
    __properties: ClassVar[List[str]] = ["listProperties", "suggestedDeletionIds", "suggestedInsertionId", "suggestedListPropertiesChanges"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of List from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of list_properties
        if self.list_properties:
            _dict['listProperties'] = self.list_properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of List from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "listProperties": ListProperties.from_dict(obj["listProperties"]) if obj.get("listProperties") is not None else None,
            "suggestedDeletionIds": obj.get("suggestedDeletionIds"),
            "suggestedInsertionId": obj.get("suggestedInsertionId"),
            "suggestedListPropertiesChanges": obj.get("suggestedListPropertiesChanges")
        })
        return _obj


