# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.paragraph_style import ParagraphStyle
from google_docs_ti.models.text_style import TextStyle
from typing import Optional, Set
from typing_extensions import Self

class NamedStyle(BaseModel):
    """
    A named style. Paragraphs in the document can inherit their TextStyle and ParagraphStyle from this named style when they have the same named style type.
    """ # noqa: E501
    named_style_type: Optional[StrictStr] = Field(default=None, description="The type of this named style.", alias="namedStyleType")
    paragraph_style: Optional[ParagraphStyle] = Field(default=None, alias="paragraphStyle")
    text_style: Optional[TextStyle] = Field(default=None, alias="textStyle")
    __properties: ClassVar[List[str]] = ["namedStyleType", "paragraphStyle", "textStyle"]

    @field_validator('named_style_type')
    def named_style_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NAMED_STYLE_TYPE_UNSPECIFIED', 'NORMAL_TEXT', 'TITLE', 'SUBTITLE', 'HEADING_1', 'HEADING_2', 'HEADING_3', 'HEADING_4', 'HEADING_5', 'HEADING_6']):
            raise ValueError("must be one of enum values ('NAMED_STYLE_TYPE_UNSPECIFIED', 'NORMAL_TEXT', 'TITLE', 'SUBTITLE', 'HEADING_1', 'HEADING_2', 'HEADING_3', 'HEADING_4', 'HEADING_5', 'HEADING_6')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NamedStyle from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of paragraph_style
        if self.paragraph_style:
            _dict['paragraphStyle'] = self.paragraph_style.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text_style
        if self.text_style:
            _dict['textStyle'] = self.text_style.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NamedStyle from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "namedStyleType": obj.get("namedStyleType"),
            "paragraphStyle": ParagraphStyle.from_dict(obj["paragraphStyle"]) if obj.get("paragraphStyle") is not None else None,
            "textStyle": TextStyle.from_dict(obj["textStyle"]) if obj.get("textStyle") is not None else None
        })
        return _obj


