# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.paragraph_style_suggestion_state import ParagraphStyleSuggestionState
from google_docs_ti.models.text_style_suggestion_state import TextStyleSuggestionState
from typing import Optional, Set
from typing_extensions import Self

class NamedStyleSuggestionState(BaseModel):
    """
    A suggestion state of a NamedStyle message.
    """ # noqa: E501
    named_style_type: Optional[StrictStr] = Field(default=None, description="The named style type that this suggestion state corresponds to. This field is provided as a convenience for matching the NamedStyleSuggestionState with its corresponding NamedStyle.", alias="namedStyleType")
    paragraph_style_suggestion_state: Optional[ParagraphStyleSuggestionState] = Field(default=None, alias="paragraphStyleSuggestionState")
    text_style_suggestion_state: Optional[TextStyleSuggestionState] = Field(default=None, alias="textStyleSuggestionState")
    __properties: ClassVar[List[str]] = ["namedStyleType", "paragraphStyleSuggestionState", "textStyleSuggestionState"]

    @field_validator('named_style_type')
    def named_style_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NAMED_STYLE_TYPE_UNSPECIFIED', 'NORMAL_TEXT', 'TITLE', 'SUBTITLE', 'HEADING_1', 'HEADING_2', 'HEADING_3', 'HEADING_4', 'HEADING_5', 'HEADING_6']):
            raise ValueError("must be one of enum values ('NAMED_STYLE_TYPE_UNSPECIFIED', 'NORMAL_TEXT', 'TITLE', 'SUBTITLE', 'HEADING_1', 'HEADING_2', 'HEADING_3', 'HEADING_4', 'HEADING_5', 'HEADING_6')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NamedStyleSuggestionState from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of paragraph_style_suggestion_state
        if self.paragraph_style_suggestion_state:
            _dict['paragraphStyleSuggestionState'] = self.paragraph_style_suggestion_state.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text_style_suggestion_state
        if self.text_style_suggestion_state:
            _dict['textStyleSuggestionState'] = self.text_style_suggestion_state.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NamedStyleSuggestionState from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "namedStyleType": obj.get("namedStyleType"),
            "paragraphStyleSuggestionState": ParagraphStyleSuggestionState.from_dict(obj["paragraphStyleSuggestionState"]) if obj.get("paragraphStyleSuggestionState") is not None else None,
            "textStyleSuggestionState": TextStyleSuggestionState.from_dict(obj["textStyleSuggestionState"]) if obj.get("textStyleSuggestionState") is not None else None
        })
        return _obj


