# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.text_style_suggestion_state import TextStyleSuggestionState
from typing import Optional, Set
from typing_extensions import Self

class NestingLevelSuggestionState(BaseModel):
    """
    A mask that indicates which of the fields on the base NestingLevel have been changed in this suggestion. For any field set to true, there's a new suggested value.
    """ # noqa: E501
    bullet_alignment_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to bullet_alignment.", alias="bulletAlignmentSuggested")
    glyph_format_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to glyph_format.", alias="glyphFormatSuggested")
    glyph_symbol_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to glyph_symbol.", alias="glyphSymbolSuggested")
    glyph_type_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to glyph_type.", alias="glyphTypeSuggested")
    indent_first_line_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to indent_first_line.", alias="indentFirstLineSuggested")
    indent_start_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to indent_start.", alias="indentStartSuggested")
    start_number_suggested: Optional[StrictBool] = Field(default=None, description="Indicates if there was a suggested change to start_number.", alias="startNumberSuggested")
    text_style_suggestion_state: Optional[TextStyleSuggestionState] = Field(default=None, alias="textStyleSuggestionState")
    __properties: ClassVar[List[str]] = ["bulletAlignmentSuggested", "glyphFormatSuggested", "glyphSymbolSuggested", "glyphTypeSuggested", "indentFirstLineSuggested", "indentStartSuggested", "startNumberSuggested", "textStyleSuggestionState"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NestingLevelSuggestionState from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of text_style_suggestion_state
        if self.text_style_suggestion_state:
            _dict['textStyleSuggestionState'] = self.text_style_suggestion_state.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NestingLevelSuggestionState from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bulletAlignmentSuggested": obj.get("bulletAlignmentSuggested"),
            "glyphFormatSuggested": obj.get("glyphFormatSuggested"),
            "glyphSymbolSuggested": obj.get("glyphSymbolSuggested"),
            "glyphTypeSuggested": obj.get("glyphTypeSuggested"),
            "indentFirstLineSuggested": obj.get("indentFirstLineSuggested"),
            "indentStartSuggested": obj.get("indentStartSuggested"),
            "startNumberSuggested": obj.get("startNumberSuggested"),
            "textStyleSuggestionState": TextStyleSuggestionState.from_dict(obj["textStyleSuggestionState"]) if obj.get("textStyleSuggestionState") is not None else None
        })
        return _obj


