# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.person_properties import PersonProperties
from google_docs_ti.models.text_style import TextStyle
from typing import Optional, Set
from typing_extensions import Self

class Person(BaseModel):
    """
    A person or email address mentioned in a document. These mentions behave as a single, immutable element containing the person's name or email address.
    """ # noqa: E501
    person_id: Optional[StrictStr] = Field(default=None, description="Output only. The unique ID of this link.", alias="personId")
    person_properties: Optional[PersonProperties] = Field(default=None, alias="personProperties")
    suggested_deletion_ids: Optional[List[StrictStr]] = Field(default=None, description="IDs for suggestions that remove this person link from the document. A Person might have multiple deletion IDs if, for example, multiple users suggest deleting it. If empty, then this person link isn't suggested for deletion.", alias="suggestedDeletionIds")
    suggested_insertion_ids: Optional[List[StrictStr]] = Field(default=None, description="IDs for suggestions that insert this person link into the document. A Person might have multiple insertion IDs if it's a nested suggested change (a suggestion within a suggestion made by a different user, for example). If empty, then this person link isn't a suggested insertion.", alias="suggestedInsertionIds")
    suggested_text_style_changes: Optional[Dict[str, Any]] = Field(default=None, description="The suggested text style changes to this Person, keyed by suggestion ID.", alias="suggestedTextStyleChanges")
    text_style: Optional[TextStyle] = Field(default=None, alias="textStyle")
    __properties: ClassVar[List[str]] = ["personId", "personProperties", "suggestedDeletionIds", "suggestedInsertionIds", "suggestedTextStyleChanges", "textStyle"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Person from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "person_id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of person_properties
        if self.person_properties:
            _dict['personProperties'] = self.person_properties.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text_style
        if self.text_style:
            _dict['textStyle'] = self.text_style.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Person from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "personId": obj.get("personId"),
            "personProperties": PersonProperties.from_dict(obj["personProperties"]) if obj.get("personProperties") is not None else None,
            "suggestedDeletionIds": obj.get("suggestedDeletionIds"),
            "suggestedInsertionIds": obj.get("suggestedInsertionIds"),
            "suggestedTextStyleChanges": obj.get("suggestedTextStyleChanges"),
            "textStyle": TextStyle.from_dict(obj["textStyle"]) if obj.get("textStyle") is not None else None
        })
        return _obj


