# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.dimension import Dimension
from typing import Optional, Set
from typing_extensions import Self

class PositionedObjectPositioning(BaseModel):
    """
    The positioning of a PositionedObject. The positioned object is positioned relative to the beginning of the Paragraph it's tethered to.
    """ # noqa: E501
    layout: Optional[StrictStr] = Field(default=None, description="The layout of this positioned object.")
    left_offset: Optional[Dimension] = Field(default=None, alias="leftOffset")
    top_offset: Optional[Dimension] = Field(default=None, alias="topOffset")
    __properties: ClassVar[List[str]] = ["layout", "leftOffset", "topOffset"]

    @field_validator('layout')
    def layout_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['POSITIONED_OBJECT_LAYOUT_UNSPECIFIED', 'WRAP_TEXT', 'BREAK_LEFT', 'BREAK_RIGHT', 'BREAK_LEFT_RIGHT', 'IN_FRONT_OF_TEXT', 'BEHIND_TEXT']):
            raise ValueError("must be one of enum values ('POSITIONED_OBJECT_LAYOUT_UNSPECIFIED', 'WRAP_TEXT', 'BREAK_LEFT', 'BREAK_RIGHT', 'BREAK_LEFT_RIGHT', 'IN_FRONT_OF_TEXT', 'BEHIND_TEXT')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PositionedObjectPositioning from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of left_offset
        if self.left_offset:
            _dict['leftOffset'] = self.left_offset.to_dict()
        # override the default output from pydantic by calling `to_dict()` of top_offset
        if self.top_offset:
            _dict['topOffset'] = self.top_offset.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PositionedObjectPositioning from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "layout": obj.get("layout"),
            "leftOffset": Dimension.from_dict(obj["leftOffset"]) if obj.get("leftOffset") is not None else None,
            "topOffset": Dimension.from_dict(obj["topOffset"]) if obj.get("topOffset") is not None else None
        })
        return _obj


