# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.tabs_criteria import TabsCriteria
from typing import Optional, Set
from typing_extensions import Self

class ReplaceNamedRangeContentRequest(BaseModel):
    """
    Replaces the contents of the specified NamedRange or NamedRanges with the given replacement content. Note that an individual NamedRange may consist of multiple discontinuous ranges. In this case, only the content in the first range will be replaced. The other ranges and their content will be deleted. In cases where replacing or deleting any ranges would result in an invalid document structure, a 400 bad request error is returned.
    """ # noqa: E501
    named_range_id: Optional[StrictStr] = Field(default=None, description="The ID of the named range whose content will be replaced. If there is no named range with the given ID a 400 bad request error is returned.", alias="namedRangeId")
    named_range_name: Optional[StrictStr] = Field(default=None, description="The name of the NamedRanges whose content will be replaced. If there are multiple named ranges with the given name, then the content of each one will be replaced. If there are no named ranges with the given name, then the request will be a no-op.", alias="namedRangeName")
    tabs_criteria: Optional[TabsCriteria] = Field(default=None, alias="tabsCriteria")
    text: Optional[StrictStr] = Field(default=None, description="Replaces the content of the specified named range(s) with the given text.")
    __properties: ClassVar[List[str]] = ["namedRangeId", "namedRangeName", "tabsCriteria", "text"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReplaceNamedRangeContentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of tabs_criteria
        if self.tabs_criteria:
            _dict['tabsCriteria'] = self.tabs_criteria.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReplaceNamedRangeContentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "namedRangeId": obj.get("namedRangeId"),
            "namedRangeName": obj.get("namedRangeName"),
            "tabsCriteria": TabsCriteria.from_dict(obj["tabsCriteria"]) if obj.get("tabsCriteria") is not None else None,
            "text": obj.get("text")
        })
        return _obj


