# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.paragraph import Paragraph
from google_docs_ti.models.section_break import SectionBreak
from typing import Optional, Set
from typing_extensions import Self

class StructuralElement(BaseModel):
    """
    A StructuralElement describes content that provides structure to the document.
    """ # noqa: E501
    end_index: Optional[StrictInt] = Field(default=None, description="The zero-based end index of this structural element, exclusive, in UTF-16 code units.", alias="endIndex")
    paragraph: Optional[Paragraph] = None
    section_break: Optional[SectionBreak] = Field(default=None, alias="sectionBreak")
    start_index: Optional[StrictInt] = Field(default=None, description="The zero-based start index of this structural element, in UTF-16 code units.", alias="startIndex")
    table: Optional[Table] = None
    table_of_contents: Optional[TableOfContents] = Field(default=None, alias="tableOfContents")
    __properties: ClassVar[List[str]] = ["endIndex", "paragraph", "sectionBreak", "startIndex", "table", "tableOfContents"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StructuralElement from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of paragraph
        if self.paragraph:
            _dict['paragraph'] = self.paragraph.to_dict()
        # override the default output from pydantic by calling `to_dict()` of section_break
        if self.section_break:
            _dict['sectionBreak'] = self.section_break.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table
        if self.table:
            _dict['table'] = self.table.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_of_contents
        if self.table_of_contents:
            _dict['tableOfContents'] = self.table_of_contents.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StructuralElement from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "endIndex": obj.get("endIndex"),
            "paragraph": Paragraph.from_dict(obj["paragraph"]) if obj.get("paragraph") is not None else None,
            "sectionBreak": SectionBreak.from_dict(obj["sectionBreak"]) if obj.get("sectionBreak") is not None else None,
            "startIndex": obj.get("startIndex"),
            "table": Table.from_dict(obj["table"]) if obj.get("table") is not None else None,
            "tableOfContents": TableOfContents.from_dict(obj["tableOfContents"]) if obj.get("tableOfContents") is not None else None
        })
        return _obj

from google_docs_ti.models.table import Table
from google_docs_ti.models.table_of_contents import TableOfContents
# TODO: Rewrite to not use raise_errors
StructuralElement.model_rebuild(raise_errors=False)

