# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.document_tab import DocumentTab
from google_docs_ti.models.tab_properties import TabProperties
from typing import Optional, Set
from typing_extensions import Self

class Tab(BaseModel):
    """
    A tab in a document.
    """ # noqa: E501
    child_tabs: Optional[List[Tab]] = Field(default=None, description="The child tabs nested within this tab.", alias="childTabs")
    document_tab: Optional[DocumentTab] = Field(default=None, alias="documentTab")
    tab_properties: Optional[TabProperties] = Field(default=None, alias="tabProperties")
    __properties: ClassVar[List[str]] = ["childTabs", "documentTab", "tabProperties"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Tab from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in child_tabs (list)
        _items = []
        if self.child_tabs:
            for _item_child_tabs in self.child_tabs:
                if _item_child_tabs:
                    _items.append(_item_child_tabs.to_dict())
            _dict['childTabs'] = _items
        # override the default output from pydantic by calling `to_dict()` of document_tab
        if self.document_tab:
            _dict['documentTab'] = self.document_tab.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tab_properties
        if self.tab_properties:
            _dict['tabProperties'] = self.tab_properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Tab from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "childTabs": [Tab.from_dict(_item) for _item in obj["childTabs"]] if obj.get("childTabs") is not None else None,
            "documentTab": DocumentTab.from_dict(obj["documentTab"]) if obj.get("documentTab") is not None else None,
            "tabProperties": TabProperties.from_dict(obj["tabProperties"]) if obj.get("tabProperties") is not None else None
        })
        return _obj

# TODO: Rewrite to not use raise_errors
Tab.model_rebuild(raise_errors=False)

