# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.table_style import TableStyle
from typing import Optional, Set
from typing_extensions import Self

class Table(BaseModel):
    """
    A StructuralElement representing a table.
    """ # noqa: E501
    columns: Optional[StrictInt] = Field(default=None, description="Number of columns in the table. It's possible for a table to be non-rectangular, so some rows may have a different number of cells.")
    rows: Optional[StrictInt] = Field(default=None, description="Number of rows in the table.")
    suggested_deletion_ids: Optional[List[StrictStr]] = Field(default=None, description="The suggested deletion IDs. If empty, then there are no suggested deletions of this content.", alias="suggestedDeletionIds")
    suggested_insertion_ids: Optional[List[StrictStr]] = Field(default=None, description="The suggested insertion IDs. A Table may have multiple insertion IDs if it's a nested suggested change. If empty, then this is not a suggested insertion.", alias="suggestedInsertionIds")
    table_rows: Optional[List[TableRow]] = Field(default=None, description="The contents and style of each row.", alias="tableRows")
    table_style: Optional[TableStyle] = Field(default=None, alias="tableStyle")
    __properties: ClassVar[List[str]] = ["columns", "rows", "suggestedDeletionIds", "suggestedInsertionIds", "tableRows", "tableStyle"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Table from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in table_rows (list)
        _items = []
        if self.table_rows:
            for _item_table_rows in self.table_rows:
                if _item_table_rows:
                    _items.append(_item_table_rows.to_dict())
            _dict['tableRows'] = _items
        # override the default output from pydantic by calling `to_dict()` of table_style
        if self.table_style:
            _dict['tableStyle'] = self.table_style.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Table from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "columns": obj.get("columns"),
            "rows": obj.get("rows"),
            "suggestedDeletionIds": obj.get("suggestedDeletionIds"),
            "suggestedInsertionIds": obj.get("suggestedInsertionIds"),
            "tableRows": [TableRow.from_dict(_item) for _item in obj["tableRows"]] if obj.get("tableRows") is not None else None,
            "tableStyle": TableStyle.from_dict(obj["tableStyle"]) if obj.get("tableStyle") is not None else None
        })
        return _obj

from google_docs_ti.models.table_row import TableRow
# TODO: Rewrite to not use raise_errors
Table.model_rebuild(raise_errors=False)

