# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.dimension import Dimension
from google_docs_ti.models.optional_color import OptionalColor
from typing import Optional, Set
from typing_extensions import Self

class TableCellBorder(BaseModel):
    """
    A border around a table cell. Table cell borders cannot be transparent. To hide a table cell border, make its width 0.
    """ # noqa: E501
    color: Optional[OptionalColor] = None
    dash_style: Optional[StrictStr] = Field(default=None, description="The dash style of the border.", alias="dashStyle")
    width: Optional[Dimension] = None
    __properties: ClassVar[List[str]] = ["color", "dashStyle", "width"]

    @field_validator('dash_style')
    def dash_style_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['DASH_STYLE_UNSPECIFIED', 'SOLID', 'DOT', 'DASH']):
            raise ValueError("must be one of enum values ('DASH_STYLE_UNSPECIFIED', 'SOLID', 'DOT', 'DASH')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TableCellBorder from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of color
        if self.color:
            _dict['color'] = self.color.to_dict()
        # override the default output from pydantic by calling `to_dict()` of width
        if self.width:
            _dict['width'] = self.width.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TableCellBorder from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "color": OptionalColor.from_dict(obj["color"]) if obj.get("color") is not None else None,
            "dashStyle": obj.get("dashStyle"),
            "width": Dimension.from_dict(obj["width"]) if obj.get("width") is not None else None
        })
        return _obj


