# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.dimension import Dimension
from typing import Optional, Set
from typing_extensions import Self

class TableRowStyle(BaseModel):
    """
    Styles that apply to a table row.
    """ # noqa: E501
    min_row_height: Optional[Dimension] = Field(default=None, alias="minRowHeight")
    prevent_overflow: Optional[StrictBool] = Field(default=None, description="Whether the row cannot overflow across page or column boundaries.", alias="preventOverflow")
    table_header: Optional[StrictBool] = Field(default=None, description="Whether the row is a table header.", alias="tableHeader")
    __properties: ClassVar[List[str]] = ["minRowHeight", "preventOverflow", "tableHeader"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TableRowStyle from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of min_row_height
        if self.min_row_height:
            _dict['minRowHeight'] = self.min_row_height.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TableRowStyle from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "minRowHeight": Dimension.from_dict(obj["minRowHeight"]) if obj.get("minRowHeight") is not None else None,
            "preventOverflow": obj.get("preventOverflow"),
            "tableHeader": obj.get("tableHeader")
        })
        return _obj


