# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.location import Location
from google_docs_ti.models.table_cell_style import TableCellStyle
from google_docs_ti.models.table_range import TableRange
from typing import Optional, Set
from typing_extensions import Self

class UpdateTableCellStyleRequest(BaseModel):
    """
    Updates the style of a range of table cells.
    """ # noqa: E501
    fields: Optional[StrictStr] = Field(default=None, description="The fields that should be updated. At least one field must be specified. The root `tableCellStyle` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field. For example to update the table cell background color, set `fields` to `\"backgroundColor\"`. To reset a property to its default value, include its field name in the field mask but leave the field itself unset.")
    table_cell_style: Optional[TableCellStyle] = Field(default=None, alias="tableCellStyle")
    table_range: Optional[TableRange] = Field(default=None, alias="tableRange")
    table_start_location: Optional[Location] = Field(default=None, alias="tableStartLocation")
    __properties: ClassVar[List[str]] = ["fields", "tableCellStyle", "tableRange", "tableStartLocation"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateTableCellStyleRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of table_cell_style
        if self.table_cell_style:
            _dict['tableCellStyle'] = self.table_cell_style.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_range
        if self.table_range:
            _dict['tableRange'] = self.table_range.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_start_location
        if self.table_start_location:
            _dict['tableStartLocation'] = self.table_start_location.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateTableCellStyleRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fields": obj.get("fields"),
            "tableCellStyle": TableCellStyle.from_dict(obj["tableCellStyle"]) if obj.get("tableCellStyle") is not None else None,
            "tableRange": TableRange.from_dict(obj["tableRange"]) if obj.get("tableRange") is not None else None,
            "tableStartLocation": Location.from_dict(obj["tableStartLocation"]) if obj.get("tableStartLocation") is not None else None
        })
        return _obj


