# coding: utf-8

"""
    Google Docs API

    Reads and writes Google Docs documents.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_docs_ti.models.location import Location
from google_docs_ti.models.table_row_style import TableRowStyle
from typing import Optional, Set
from typing_extensions import Self

class UpdateTableRowStyleRequest(BaseModel):
    """
    Updates the TableRowStyle of rows in a table.
    """ # noqa: E501
    fields: Optional[StrictStr] = Field(default=None, description="The fields that should be updated. At least one field must be specified. The root `tableRowStyle` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field. For example to update the minimum row height, set `fields` to `\"min_row_height\"`.")
    row_indices: Optional[List[StrictInt]] = Field(default=None, description="The list of zero-based row indices whose style should be updated. If no indices are specified, all rows will be updated.", alias="rowIndices")
    table_row_style: Optional[TableRowStyle] = Field(default=None, alias="tableRowStyle")
    table_start_location: Optional[Location] = Field(default=None, alias="tableStartLocation")
    __properties: ClassVar[List[str]] = ["fields", "rowIndices", "tableRowStyle", "tableStartLocation"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateTableRowStyleRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of table_row_style
        if self.table_row_style:
            _dict['tableRowStyle'] = self.table_row_style.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_start_location
        if self.table_start_location:
            _dict['tableStartLocation'] = self.table_start_location.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateTableRowStyleRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fields": obj.get("fields"),
            "rowIndices": obj.get("rowIndices"),
            "tableRowStyle": TableRowStyle.from_dict(obj["tableRowStyle"]) if obj.get("tableRowStyle") is not None else None,
            "tableStartLocation": Location.from_dict(obj["tableStartLocation"]) if obj.get("tableStartLocation") is not None else None
        })
        return _obj


